Index: XIOS/dev/dev_olga/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/domain.cpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/domain.cpp	(revision 1099)
@@ -2465,30 +2596,29 @@
     }
 
-    int nbLatInd = 0;
+    latvalue.resize(zoom_ni*zoom_nj);
+    latvalue = 0;
+
+    if (hasBounds)
+    {
+      bounds_latvalue.resize(nvertex,zoom_ni*zoom_nj);
+      bounds_latvalue = 0. ;
+    }
+    
     for (i = 0; i < nbReceived; ++i)
     {
-      nbLatInd += recvLatValue[i].numElements();
-    }
-
-    latvalue.resize(nbLatInd);
-    if (hasBounds)
-    {
-      bounds_latvalue.resize(nvertex, nbLatInd);
-    }
-    
-    nbLatInd = 0;
-    for (i = 0; i < nbReceived; ++i)
-    {
-      CArray<double,1>& tmp = recvLatValue[i];
-      for (ind = 0; ind < tmp.numElements(); ++ind)
-      {         
-         latvalue(nbLatInd) = tmp(ind);
+      int rank = recvClientRanks_[i];
+      CArray<int,1> &indi = indGlob_[rank], &indj = indGlob_[rank];
+      CArray<double,1>& lat = recvLatValue[i];
+      for (ind = 0; ind < indi.numElements(); ++ind)
+      {
+         iindex = indi(ind) % ni_glo; jindex = indj(ind) / ni_glo;
+         index = (iindex - zoom_ibegin) + (jindex - zoom_jbegin) * zoom_ni;
+         latvalue(index) = lat(ind);
          if (hasBounds)
          {
-          CArray<double,2>& tmpBnds = recvBoundsLatValue[i];
+          CArray<double,2>& boundslat = recvBoundsLatValue[i];
           for (int nv = 0; nv < nvertex; ++nv)
-            bounds_latvalue(nv, nbLatInd) = tmpBnds(nv, ind);
-         }       
-         ++nbLatInd;
+            bounds_latvalue(nv, index) = boundslat(nv, ind);
+         }         
       }
     }
Index: XIOS/dev/dev_olga/src/node/domain.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/domain.hpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/domain.hpp	(revision 1099)
@@ -201,4 +201,5 @@
          std::vector<int> global_write_size_;
 
+         bool doZoomByIndex_;
          bool isChecked;
          std::set<StdString> relFiles, relFilesCompressed;
Index: XIOS/dev/dev_olga/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/field.cpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/field.cpp	(revision 1099)
@@ -125,8 +125,7 @@
 //    CContextClient* client = context->client;
     // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
-//    int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
-//    for (int i = 0; i < nbSrvPools; ++i)
-//    {
-//      CContextClient* client = (!context->hasServer) ? context->client : context->clientPrimServer[i];
+    // int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
+    // for (int i = 0; i < nbSrvPools; ++i)
+    // {
       CContextClient* client = (!context->hasServer) ? context->client : this->file->getContextClient();
 
@@ -173,67 +172,66 @@
 
           list_msg.back() << getId() << data_tmp;
-          event.push(rank, grid->nbSenders[rank], list_msg.back());
+          event.push(rank, grid->nbSenders[0][rank], list_msg.back());
         }
         client->sendEvent(event);
       }
-//    }
+    // }
 
     CTimer::get("XIOS Send Data").suspend();
   }
 
-/*
-  void CField::sendUpdateData(const CArray<double,1>& data, CContextClient* client)
-  {
-    CTimer::get("XIOS Send Data").resume();
-
-    CEventClient event(getType(), EVENT_ID_UPDATE_DATA);
-
-    map<int, CArray<int,1> >::iterator it;
-    list<CMessage> list_msg;
-    list<CArray<double,1> > list_data;
-
-    if (!grid->doGridHaveDataDistributed())
-    {
-       if (client->isServerLeader())
-       {
-          for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
-          {
-            int rank = it->first;
-            CArray<int,1>& index = it->second;
-
-            list_msg.push_back(CMessage());
-            list_data.push_back(CArray<double,1>(index.numElements()));
-
-            CArray<double,1>& data_tmp = list_data.back();
-            for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
-
-            list_msg.back() << getId() << data_tmp;
-            event.push(rank, 1, list_msg.back());
-          }
-          client->sendEvent(event);
-       }
-       else client->sendEvent(event);
-    }
-    else
-    {
-      for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
-      {
-        int rank = it->first;
-        CArray<int,1>& index = it->second;
-
-        list_msg.push_back(CMessage());
-        list_data.push_back(CArray<double,1>(index.numElements()));
-
-        CArray<double,1>& data_tmp = list_data.back();
-        for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
-
-        list_msg.back() << getId() << data_tmp;
-        event.push(rank, grid->nbSenders[rank], list_msg.back());
-      }
-      client->sendEvent(event);
-    }
-    CTimer::get("XIOS Send Data").suspend();
-  }
-*/
+  // void CField::sendUpdateData(const CArray<double,1>& data, CContextClient* client)
+  // {
+  //   CTimer::get("XIOS Send Data").resume();
+
+  //   CEventClient event(getType(), EVENT_ID_UPDATE_DATA);
+
+  //   map<int, CArray<int,1> >::iterator it;
+  //   list<CMessage> list_msg;
+  //   list<CArray<double,1> > list_data;
+
+  //   if (!grid->doGridHaveDataDistributed())
+  //   {
+  //      if (client->isServerLeader())
+  //      {
+  //         for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
+  //         {
+  //           int rank = it->first;
+  //           CArray<int,1>& index = it->second;
+
+  //           list_msg.push_back(CMessage());
+  //           list_data.push_back(CArray<double,1>(index.numElements()));
+
+  //           CArray<double,1>& data_tmp = list_data.back();
+  //           for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
+
+  //           list_msg.back() << getId() << data_tmp;
+  //           event.push(rank, 1, list_msg.back());
+  //         }
+  //         client->sendEvent(event);
+  //      }
+  //      else client->sendEvent(event);
+  //   }
+  //   else
+  //   {
+  //     for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
+  //     {
+  //       int rank = it->first;
+  //       CArray<int,1>& index = it->second;
+
+  //       list_msg.push_back(CMessage());
+  //       list_data.push_back(CArray<double,1>(index.numElements()));
+
+  //       CArray<double,1>& data_tmp = list_data.back();
+  //       for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
+
+  //       list_msg.back() << getId() << data_tmp;
+  //       event.push(rank, grid->nbSenders[rank], list_msg.back());
+  //     }
+  //     client->sendEvent(event);
+  //   }
+  //   CTimer::get("XIOS Send Data").suspend();
+  // }
+
   void CField::recvUpdateData(CEventServer& event)
   {
@@ -263,4 +261,5 @@
       {
         sizeData += it->second.numElements();
+        data_srv.insert(std::make_pair(it->first, CArray<double,1>(it->second.numElements())));
       }
 
@@ -271,7 +270,7 @@
 
     CArray<double,1> recv_data_tmp(recvDataSrv.numElements());
-    sizeData = 0;
+    // sizeData = 0;
     const CDate& currDate = context->getCalendar()->getCurrentDate();
-    const CDate opeDate      = last_operation_srv +freq_op + freq_operation_srv - freq_op;
+    const CDate opeDate   = last_operation_srv +freq_op + freq_operation_srv - freq_op;
 
     if (opeDate <= currDate)
@@ -279,8 +278,13 @@
       for (map<int, CArray<size_t, 1> >::iterator it = grid->outIndexFromClient.begin(); it != grid->outIndexFromClient.end(); ++it)
       {        
-        CArray<double,1> tmp;       
+        CArray<double,1> tmp;
+        CArray<size_t,1>& indexTmp = it->second;
         *(rankBuffers[it->first]) >> tmp;
-        recv_data_tmp(Range(sizeData,sizeData+it->second.numElements()-1)) = tmp;  
-        sizeData += it->second.numElements();      
+        for (int idx = 0; idx < indexTmp.numElements(); ++idx)
+        {
+          recv_data_tmp(indexTmp(idx)) = tmp(idx);
+        }
+        // recv_data_tmp(Range(sizeData,sizeData+it->second.numElements()-1)) = tmp;  
+        // sizeData += it->second.numElements();      
       }
     }
@@ -525,5 +529,5 @@
         else
           msg << int(-1);
-        event.push(it->first, grid->nbSenders[it->first], msg);
+        event.push(it->first, grid->nbSenders[0][it->first], msg);
       }
       client->sendEvent(event);
@@ -924,5 +928,5 @@
    }
 
-   std::map<int, StdSize> CField::getGridDataBufferSize()
+   std::vector<std::map<int, StdSize> > CField::getGridDataBufferSize()
    {
      return grid->getDataBufferSize(getId());
@@ -1424,11 +1428,13 @@
    void CField::outputField(CArray<double,1>& fieldOut)
    {
-      // map<int, CArray<double,1> >::iterator it;
-
+      map<int, CArray<double,1> >::iterator it;
+      
+      fieldOut = recvDataSrv;
+      
       // for (it = data_srv.begin(); it != data_srv.end(); it++)
       // {
       //    grid->outputField(it->first, it->second, fieldOut.dataFirst());
       // }
-    grid->outputField(recvDataSrv, fieldOut);
+    // grid->outputField(recvDataSrv, fieldOut);
    }
 
Index: XIOS/dev/dev_olga/src/node/field.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/field.hpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/field.hpp	(revision 1099)
@@ -96,5 +96,5 @@
 
          std::map<int, StdSize> getGridAttributesBufferSize();
-         std::map<int, StdSize> getGridDataBufferSize();
+         std::vector<std::map<int, StdSize> > getGridDataBufferSize(); // Grid data buffer size for each connection of contextclient
 
        public:
@@ -146,5 +146,5 @@
         static bool dispatchEvent(CEventServer& event);
         void sendUpdateData(const CArray<double,1>& data);
-//        void sendUpdateData(const CArray<double,1>& data, CContextClient* client);
+        void sendUpdateData(const CArray<double,1>& data, CContextClient* client);
         static void recvUpdateData(CEventServer& event);
         void recvUpdateData(std::map<int,CBufferIn*>& rankBuffers);
Index: XIOS/dev/dev_olga/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1077)
+++ XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1099)
@@ -96,4 +96,5 @@
     *
     * \return A map associating the server rank with its minimum buffer size.
+    * TODO: Refactor code
     */
    std::map<int, StdSize> CGrid::getAttributesBufferSize()
@@ -102,18 +103,22 @@
 
      // The grid indexes require a similar size as the actual data
-     std::map<int, StdSize> dataSizes = getDataBufferSize();
-     std::map<int, StdSize>::iterator it, itE = dataSizes.end();
-     for (it = dataSizes.begin(); it != itE; ++it)
+     std::vector<std::map<int, StdSize> > dataSizes = getDataBufferSize();
+     for (size_t i = 0; i < dataSizes.size(); ++i)
      {
-       it->second += 2 * sizeof(bool);
-       if (it->second > attributesSizes[it->first])
-         attributesSizes[it->first] = it->second;
+       std::map<int, StdSize>::iterator it, itE = dataSizes[i].end();
+       for (it = dataSizes[i].begin(); it != itE; ++it)
+       {
+         it->second += 2 * sizeof(bool);
+         if (it->second > attributesSizes[it->first])
+           attributesSizes[it->first] = it->second;
+       }
      }
 
+     std::map<int, StdSize>::iterator it, itE;
      // Account for the axis attributes
      std::vector<CAxis*> axisList = getAxis();
      for (size_t i = 0; i < axisList.size(); ++i)
      {
-       std::map<int, StdSize> axisAttBuffSize = axisList[i]->getAttributesBufferSize();
+       std::map<int, StdSize> axisAttBuffSize = axisList[i]->getAttributesBufferSize();       
        for (it = axisAttBuffSize.begin(), itE = axisAttBuffSize.end(); it != itE; ++it)
        {
@@ -144,19 +149,23 @@
     * \return A map associating the server rank with its minimum buffer size.
     */
-   std::map<int, StdSize> CGrid::getDataBufferSize(const std::string& id /*= ""*/)
-   {
-     std::map<int, StdSize> dataSizes;
+   std::vector<std::map<int, StdSize> > CGrid::getDataBufferSize(const std::string& id /*= ""*/)
+   {     
      // The record index is sometimes sent along with the data but we always
      // include it in the size calculation for the sake of simplicity
      const size_t extraSize = CEventClient::headerSize + (id.empty() ? getId() : id).size() + 2 * sizeof(size_t);
-
-     std::map<int, size_t>::const_iterator itEnd = connectedDataSize_.end();
-     for (size_t k = 0; k < connectedServerRank_.size(); ++k)
+     CContext* context = CContext::getCurrent();
+     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
+     std::vector<std::map<int, StdSize> > dataSizes(nbSrvPools);
+     for (int p = 0; p < nbSrvPools; ++p) 
      {
-       int rank = connectedServerRank_[k];
-       std::map<int, size_t>::const_iterator it = connectedDataSize_.find(rank);
-       size_t count = (it != itEnd) ? it->second : 0;
-
-       dataSizes.insert(std::make_pair(rank, extraSize + CArray<double,1>::size(count)));
+       std::map<int, size_t>::const_iterator itEnd = connectedDataSize_[p].end();
+       for (size_t k = 0; k < connectedServerRank_[p].size(); ++k) // TODO: Should change connectedServerRank_[0] to something more general
+       {
+         int rank = connectedServerRank_[p][k];
+         std::map<int, size_t>::const_iterator it = connectedDataSize_[0].find(rank);
+         size_t count = (it != itEnd) ? it->second : 0;
+
+         dataSizes[p].insert(std::make_pair(rank, extraSize + CArray<double,1>::size(count)));
+       }
      }
 
@@ -276,5 +285,5 @@
      int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;   
      nbSrvPools = 1;  
-     for (int i = 0; i < nbSrvPools; ++i)
+     for (int p = 0; p < nbSrvPools; ++p)
      {       
        if (isScalarGrid())
@@ -304,5 +313,7 @@
      if (this->isChecked) return;
      this->checkAttributesAfterTransformation();
-     this->checkMask();
+
+     // TODO: Transfer grid attributes
+     if (!context->hasClient && context->hasServer) this->createMask();
      this->computeIndex();
 
@@ -506,8 +517,7 @@
      // It works only for the same number of procs on secondary pools
      int nbSrvPools = 1; 
-
-     for (int i = 0; i < nbSrvPools; ++i)
+     for (int p = 0; p < nbSrvPools; ++p)
      {
-       CContextClient* client = (context->hasServer) ? (context->hasClient ? context->clientPrimServer[i] : context->client) : context->client;
+       CContextClient* client = (context->hasServer) ? (context->hasClient ? context->clientPrimServer[p] : context->client) : context->client;
        // CContextClient* client = (context->hasServer) ? context->clientPrimServer[i] : context->client;
        // CContextServer* server = (context->hasServer) ? context->server : 0 ;
@@ -517,12 +527,19 @@
        // First of all, compute distribution on client side
        if (0 != serverDistribution_)
+       {
          clientDistribution_ = new CDistributionClient(rank, this, serverDistribution_->getGlobalLocalIndex());
+         storeIndex_client.resize(serverDistribution_->getGridSize());
+         int nbStoreIndex = storeIndex_client.numElements();
+         for (int idx = 0; idx < nbStoreIndex; ++idx) storeIndex_client(idx) = idx;
+       }
        else
+       {
          clientDistribution_ = new CDistributionClient(rank, this);
-
-       // Get local data index on client
-       storeIndex_client.resize(clientDistribution_->getLocalDataIndexOnClient().size());
-       int nbStoreIndex = storeIndex_client.numElements();
-       for (int idx = 0; idx < nbStoreIndex; ++idx) storeIndex_client(idx) = (clientDistribution_->getLocalDataIndexOnClient())[idx];
+         // Get local data index on client
+         storeIndex_client.resize(clientDistribution_->getLocalDataIndexOnClient().size());
+         int nbStoreIndex = storeIndex_client.numElements();
+         for (int idx = 0; idx < nbStoreIndex; ++idx) storeIndex_client(idx) = (clientDistribution_->getLocalDataIndexOnClient())[idx];
+       }
+     
        if (0 == serverDistribution_) 
         isDataDistributed_= clientDistribution_->isDataDistributed();
@@ -535,10 +552,13 @@
      // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
      int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
-     // int nbSrvPools = 1;
-     for (int i = 0; i < nbSrvPools; ++i)
+     connectedServerRank_.resize(nbSrvPools);
+     connectedDataSize_.resize(nbSrvPools);
+     nbSenders.resize(nbSrvPools);
+
+     for (int p = 0; p < nbSrvPools; ++p)
      {
-       CContextClient* client = (context->hasServer) ? context->clientPrimServer[i] : context->client;
-
-       connectedServerRank_.clear();
+       CContextClient* client = (context->hasServer) ? context->clientPrimServer[p] : context->client;
+
+       connectedServerRank_[p].clear();
 
        if (!doGridHaveDataDistributed())
@@ -550,6 +570,6 @@
             for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
             {
-              connectedServerRank_.push_back(*itRank);
-              connectedDataSize_[*itRank] = ssize;
+              connectedServerRank_[p].push_back(*itRank);
+              connectedDataSize_[p][*itRank] = ssize;
             }
           }
@@ -583,8 +603,8 @@
             if (iteGlobalLocalIndexMap != itGlobalLocalIndexMap)
             {
-               if (connectedDataSize_.end() == connectedDataSize_.find(serverRank))
-                 connectedDataSize_[serverRank] = 1;
+               if (connectedDataSize_[p].end() == connectedDataSize_[p].find(serverRank))
+                 connectedDataSize_[p][serverRank] = 1;
                else
-                 ++connectedDataSize_[serverRank];
+                 ++connectedDataSize_[p][serverRank];
             }
          }
@@ -592,8 +612,8 @@
 
        for (itGlobalMap = itbGlobalMap; itGlobalMap != iteGlobalMap; ++itGlobalMap) {
-         connectedServerRank_.push_back(itGlobalMap->first);
+         connectedServerRank_[p].push_back(itGlobalMap->first);
        }
 
-       nbSenders = clientServerMap_->computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_);
+       nbSenders[p] = clientServerMap_->computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_[p]);
      }
    }
@@ -626,4 +646,5 @@
      // isDataDistributed_= clientDistribution_->isDataDistributed();
 
+
      // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
 
@@ -633,5 +654,4 @@
        computeConnectedClients();
      }
-
 
      // connectedServerRank_.clear();
@@ -708,7 +728,7 @@
      int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
      nbSrvPools = 1;
-     for (int i = 0; i < nbSrvPools; ++i)
+     for (int p = 0; p < nbSrvPools; ++p)
      {
-       CContextClient* client = context->hasServer ? context->clientPrimServer[i] : context->client;
+       CContextClient* client = context->hasServer ? context->clientPrimServer[p] : context->client;
        int serverSize = client->serverSize;
        std::vector<CDomain*> domList = getDomains();
@@ -1139,12 +1159,16 @@
     // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
-    for (int i = 0; i < nbSrvPools; ++i)
-    {
-      CContextClient* client = context->hasServer ? context->clientPrimServer[i] : context->client;
+    connectedServerRank_.resize(nbSrvPools);
+    connectedDataSize_.resize(nbSrvPools);
+    nbSenders.resize(nbSrvPools);
+
+    for (int p = 0; p < nbSrvPools; ++p)
+    {
+      CContextClient* client = context->hasServer ? context->clientPrimServer[p] : context->client;
 
       storeIndex_client.resize(1);
       storeIndex_client(0) = 0;
 
-      connectedServerRank_.clear();
+      connectedServerRank_[p].clear();
 
       if (0 == client->clientRank)
@@ -1152,7 +1176,7 @@
         for (int rank = 0; rank < client->serverSize; ++rank)
         {
-          connectedServerRank_.push_back(rank);
-          connectedDataSize_[rank] = 1;
-          nbSenders[rank] = 1;
+          connectedServerRank_[p].push_back(rank);
+          connectedDataSize_[p][rank] = 1;
+          nbSenders[p][rank] = 1;
         }
       }
@@ -1200,7 +1224,7 @@
     // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
-    for (int i = 0; i < nbSrvPools; ++i)
-    {
-      CContextClient* client = context->hasServer ? context->clientPrimServer[i] : context->client;
+    for (int p = 0; p < nbSrvPools; ++p)
+    {
+      CContextClient* client = context->hasServer ? context->clientPrimServer[p] : context->client;
 
       CEventClient event(getType(), EVENT_ID_INDEX);
@@ -1257,6 +1281,4 @@
   {
     CContext* context = CContext::getCurrent();
-//    CContextClient* client = context->client;
-    // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
     for (int p = 0; p < nbSrvPools; ++p)
@@ -1368,7 +1390,7 @@
         }
 
-        for (int ns = 0; ns < connectedServerRank_.size(); ++ns)
+        for (int ns = 0; ns < connectedServerRank_[p].size(); ++ns)
         {
-          rank = connectedServerRank_[ns];
+          rank = connectedServerRank_[p][ns];
           int nb = 0;
           if (globalIndexTmp.end() != globalIndexTmp.find(rank))
@@ -1391,5 +1413,5 @@
           listMsg.back() << getId() << isDataDistributed_ << isCompressible_ << listOutIndex.back();
 
-          event.push(rank, nbSenders[rank], listMsg.back());
+          event.push(rank, nbSenders[p][rank], listMsg.back());
         }
 
@@ -1419,6 +1441,9 @@
   {
     CContext* context = CContext::getCurrent();
+
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 1) : 1;
     nbSrvPools = 1;
+    // connectedServerRank_.resize(nbSrvPools);
+    // nbSenders.resize(nbSrvPools);
     for (int p = 0; p < nbSrvPools; ++p)
     {
@@ -1428,5 +1453,5 @@
 //      CContextClient* client = (context->hasServer) ? context->client : context->clientPrimServer[p];
       numberWrittenIndexes_ = totalNumberWrittenIndexes_ = offsetWrittenIndexes_ = 0;
-      connectedServerRank_ = ranks;
+      //connectedServerRank_[p] = ranks;
 
       for (int n = 0; n < ranks.size(); n++)
@@ -1465,46 +1490,46 @@
             if (2 == axis_domain_order(i)) //domain
             {
-              // nZoomBegin[indexMap[i]] = domainList[domainId]->zoom_ibegin_srv;
-              // nZoomSize[indexMap[i]]  = domainList[domainId]->zoom_ni_srv;
-              // nZoomBeginGlobal[indexMap[i]] = domainList[domainId]->global_zoom_ibegin;
+              nZoomBegin[indexMap[i]] = domainList[domainId]->zoom_ibegin;
+              nZoomSize[indexMap[i]]  = domainList[domainId]->zoom_ni;
+              nZoomBeginGlobal[indexMap[i]] = domainList[domainId]->global_zoom_ibegin;
               // zoomIndex.push_back(domainList[domainId]->zoom_i_index);
-              // nGlob[indexMap[i]] = domainList[domainId]->ni_glo;
-
-              // nZoomBegin[indexMap[i] + 1] = domainList[domainId]->zoom_jbegin_srv;
-              // nZoomSize[indexMap[i] + 1] = domainList[domainId]->zoom_nj_srv;
-              // nZoomBeginGlobal[indexMap[i] + 1] = domainList[domainId]->global_zoom_jbegin;
+              nGlob[indexMap[i]] = domainList[domainId]->ni_glo;
+
+              nZoomBegin[indexMap[i] + 1] = domainList[domainId]->zoom_jbegin;
+              nZoomSize[indexMap[i] + 1] = domainList[domainId]->zoom_nj;
+              nZoomBeginGlobal[indexMap[i] + 1] = domainList[domainId]->global_zoom_jbegin;
               // zoomIndex.push_back(domainList[domainId]->zoom_j_index);
-              // nGlob[indexMap[i] + 1] = domainList[domainId]->nj_glo;
-
-              int nbZoom = domainList[domainId]->zoom_i_index.numElements();
-              zoomIndex.push_back(CArray<int,1>(nbZoom));
-              CArray<int,1>& zoomDomain = zoomIndex.back();
-              for (int ind = 0; ind < nbZoom; ++ind)
-              {
-                zoomDomain(ind) = domainList[domainId]->zoom_i_index(ind) + domainList[domainId]->zoom_j_index(ind) * domainList[domainId]->ni_glo;
-              }
-
-              globalSize *= domainList[domainId]->ni_glo * domainList[domainId]->nj_glo;
+              nGlob[indexMap[i] + 1] = domainList[domainId]->nj_glo;
+
+              // int nbZoom = domainList[domainId]->zoom_i_index.numElements();
+              // zoomIndex.push_back(CArray<int,1>(nbZoom));
+              // CArray<int,1>& zoomDomain = zoomIndex.back();
+              // for (int ind = 0; ind < nbZoom; ++ind)
+              // {
+              //   zoomDomain(ind) = domainList[domainId]->zoom_i_index(ind) + domainList[domainId]->zoom_j_index(ind) * domainList[domainId]->ni_glo;
+              // }
+
+              // globalSize *= domainList[domainId]->ni_glo * domainList[domainId]->nj_glo;
               ++domainId;
             }
             else if (1 == axis_domain_order(i)) // axis
             {
-              // nZoomBegin[indexMap[i]] = axisList[axisId]->zoom_begin_srv;
-              // nZoomSize[indexMap[i]]  = axisList[axisId]->zoom_size_srv;
-              // nZoomBeginGlobal[indexMap[i]] = axisList[axisId]->global_zoom_begin;
-              zoomIndex.push_back(axisList[axisId]->zoom_index);
-              // nGlob[indexMap[i]] = axisList[axisId]->n_glo;
-              globalSize *= axisList[axisId]->n_glo;
+              nZoomBegin[indexMap[i]] = axisList[axisId]->zoom_begin;
+              nZoomSize[indexMap[i]]  = axisList[axisId]->zoom_n;
+              nZoomBeginGlobal[indexMap[i]] = axisList[axisId]->global_zoom_begin;
+              // zoomIndex.push_back(axisList[axisId]->zoom_index);
+              nGlob[indexMap[i]] = axisList[axisId]->n_glo;
+              // globalSize *= axisList[axisId]->n_glo;
               ++axisId;
             }
             else // scalar
             {
-              CArray<int,1> zoomScalar(1);
-              zoomScalar(0) = 0;
-              // nZoomBegin[indexMap[i]] = 0;
-              // nZoomSize[indexMap[i]]  = 1;
-              // nZoomBeginGlobal[indexMap[i]] = 0;
-              zoomIndex.push_back(zoomScalar);
-              // nGlob[indexMap[i]] = 1;
+              // CArray<int,1> zoomScalar(1);
+              // zoomScalar(0) = 0;
+              nZoomBegin[indexMap[i]] = 0;
+              nZoomSize[indexMap[i]]  = 1;
+              nZoomBeginGlobal[indexMap[i]] = 0;
+              // zoomIndex.push_back(zoomScalar);
+              nGlob[indexMap[i]] = 1;
               ++scalarId;
             }
@@ -1512,19 +1537,21 @@
           dataSize = 1;
 
-          // for (int i = 0; i < nZoomSize.size(); ++i)
-          //   dataSize *= nZoomSize[i];
-          // serverDistribution_ = new CDistributionServer(server->intraCommRank, nZoomBegin, nZoomSize,
-          //                                               nZoomBeginGlobal, nGlob);
-          for (int i = 0; i < zoomIndex.size(); ++i)
-          {
-            dataSize *= zoomIndex[i].numElements();
-          }
-          serverDistribution_ = new CDistributionServer(server->intraCommRank, zoomIndex, nGlobElement);
+          for (int i = 0; i < nZoomSize.size(); ++i)
+            dataSize *= nZoomSize[i];
+          serverDistribution_ = new CDistributionServer(server->intraCommRank, nZoomBegin, nZoomSize,
+                                                        nZoomBeginGlobal, nGlob);
+          // for (int i = 0; i < zoomIndex.size(); ++i)
+          // {
+          //   dataSize *= zoomIndex[i].numElements();
+          // }
+          // serverDistribution_ = new CDistributionServer(server->intraCommRank, zoomIndex, nGlobElement);
         }
 
         CArray<size_t,1> outIndex;
         buffer >> outIndex;
+        serverDistribution_->computeLocalIndex(outIndex);
+
         if (isDataDistributed_)
-          serverDistribution_->computeLocalIndex(outIndex);
+        {}
         else
         {
@@ -1533,7 +1560,8 @@
           // THE PROBLEM HERE IS THAT DATA CAN BE NONDISTRIBUTED ON CLIENT AND DISTRIBUTED ON SERVER
           // BELOW IS THE TEMPORARY FIX only for a single type of element (domain, asix, scalar)
-          dataSize = serverDistribution_->getGlobalIndexEachDimension()[0].numElements();
-          outIndex.resize(dataSize);
-          outIndex = serverDistribution_->getGlobalIndexEachDimension()[0];
+          dataSize = serverDistribution_->getGridSize();
+          // dataSize = serverDistribution_->getGlobalIndexEachDimension()[0].numElements();
+          // outIndex.resize(dataSize);
+          // outIndex = serverDistribution_->getGlobalIndexEachDimension()[0];
 
         }
@@ -1541,22 +1569,22 @@
 
         outIndexFromClient.insert(std::make_pair(rank, outIndex));
-        connectedDataSize_[rank] = outIndex.numElements();
+        // connectedDataSize_[p][rank] = outIndex.numElements();
         numberWrittenIndexes_ += outIndex.numElements();
       }
 
-      int sizeData = 0;
-      for (map<int, CArray<size_t, 1> >::iterator it = outIndexFromClient.begin(); it != outIndexFromClient.end(); ++it)
-      {
-        sizeData += it->second.numElements();
-      }
-      indexFromClients.resize(sizeData);
-      sizeData = 0;
-      for (map<int, CArray<size_t, 1> >::iterator it = outIndexFromClient.begin(); it != outIndexFromClient.end(); ++it)
-      {
-         CArray<size_t, 1>& tmp0 = it->second;
-         CArray<size_t, 1> tmp1 = indexFromClients(Range(sizeData, sizeData + tmp0.numElements() - 1));
-         tmp1 = tmp0;
-         sizeData += tmp0.numElements();
-      }
+      // int sizeData = 0;
+      // for (map<int, CArray<size_t, 1> >::iterator it = outIndexFromClient.begin(); it != outIndexFromClient.end(); ++it)
+      // {
+      //   sizeData += it->second.numElements();
+      // }
+      // indexFromClients.resize(sizeData);
+      // sizeData = 0;
+      // for (map<int, CArray<size_t, 1> >::iterator it = outIndexFromClient.begin(); it != outIndexFromClient.end(); ++it)
+      // {
+      //    CArray<size_t, 1>& tmp0 = it->second;
+      //    CArray<size_t, 1> tmp1 = indexFromClients(Range(sizeData, sizeData + tmp0.numElements() - 1));
+      //    tmp1 = tmp0;
+      //    sizeData += tmp0.numElements();
+      // }
 
       // if (isScalarGrid()) return;
@@ -1571,5 +1599,5 @@
         totalNumberWrittenIndexes_ = numberWrittenIndexes_;
 
-      nbSenders = CClientServerMappingDistributed::computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, ranks);
+      // nbSenders[p] = CClientServerMappingDistributed::computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, ranks);
     }
   }
